/*
        Program Name : Operatio
        Package Name : LB
        Purpose      : Operation logger
        Institution  : Conroy & Conroy Co.
        Date Written :
        Written By   : Alan Conroy
        Version      : 1.0

	Copyright (c) 2002 by Alan Conroy.  Released to the public domain.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *    DATE        BY          REASON                         *
        *                                                           *
        *                                                           *
        *************************************************************

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

	  TOperation_Logger is used to log and undo operations.
*/

struct ROperation
{
    long int Transaction ; // Transaction number
    int Type ; // Transation type
    void (*ID)(int,void*) ; // User-supplied ID
    void *Data ; // Data to pass to Undo routine
    ROperation *Next ; // Pointer to next operation
} ;


class TOperation_Logger
{
    public:
	ROperation *Root ; // Root of operation list
	int Max_Operations ; // Maximum logged operations
	int Count ; // Count of logged operations
	long int Transaction_Number ; // Current transaction number
	int Transaction_Type ; // Current transaction type
	BOOL Original ; // True if original operation is on the list

	TOperation_Logger( int max ) ;
	~TOperation_Logger() ;
	void Set_Maximum( int max ) ;
	void Zero() ;
	void New_Transaction( int Type ) ;
	void Unwind( int Code ) ;
	void New_Operation( void (*id)(int,void*), void *data ) ;
	int Query_Type() ;

    protected:
	void Check_Extras() ;
} ;
