{$E+}
{$N+}
{
        Program Name : OS_Windows
        Package Name : LB
        Purpose      : MS Windows Operating system interface
        Institution  : Conroy & Conroy Co.
        Date Written : 6-Nov-2002
        Written By   : Alan Conroy
        Version      : 1.0

	Copyright (C) 2002 by Alan Conroy.  Released to the public domain.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *    DATE        BY          REASON                         *
        *                                                           *
        *   2-Dec-2002   EAC         Address string initialization. *
        *                                                           *
        *************************************************************

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

}

unit OS_Windows ;

interface

{$I EDEFINES.INC}

uses // Borland...
     Forms, // Application
     SysUtils, // inttostr

     // Layer 0...
     _DebugIn, // TDebug_Interface
     _Types, { int64 }

     // Layer 1...
     _DevMan, { PSDevice_Manager }
     _UEHDefs, { TUEC }
     _OS ; { TOperating_System }

type TSOS_Windows = object( TSOperating_System )
                             public { Constructors and destructors... }
                                 constructor Init ;
                                 destructor Done ; virtual ;

			     private { Instance data... }
                                 Input_Buffer : string ;
                                 Internal_Clipboard : string ;
                                 _Device_Manager : PSDevice_Manager ;

                             public { API... }
				 function Name : string ; virtual ; { O/S name }
				 function Version : string ; virtual ;
				 { O/S version }

                                 function Application_Path : string ; virtual ;
                                 procedure Beep( Typ : integer ) ; virtual ;
                                 procedure Cancel_Typeahead ; virtual ;
			         function Command_Line : string ; virtual ;
{$IFDEF DELPHI}
                                 function Debugger : PSDebug_Interface ;
                                     virtual ;
                                 { Returns a debugger for the operating system }
{$ENDIF}
                                 function Get_Char( Wait : boolean ;
                                     var Valid : boolean ) : char ; virtual ;
                                 function Get_Symbol( const X : string ) : string ;
                                     virtual ;
                                 procedure Get_Date( var Year, Month, Day : word ) ;
                                     virtual ;
                                 procedure Get_Time( var Hour, Minute, Second, Hundreths : word ) ;
                                     virtual ;
                                 procedure Last_Error( var UEC : TUEC ) ;
                                     virtual ;
                                 function Error_Text( const UEC : TUEC ;
                                     const Language : string ) : string ; virtual ;
                                 function Pending_Input : boolean ; virtual ;
                                 function PID : longint ; virtual ;
                                 procedure Print( T : string ) ; virtual ;
                                 procedure Spawn( const Path, Parameters : string ) ;
                                     virtual ;
                                 function Get_Temp_Path : string ; virtual ;
                                 function System_Path : string ; virtual ;
                                 function Swap_File_List : string ; virtual ;
				 function Timestamp : int64 ; virtual ;
                                 function Get_Clipboard( Path : string ) : string ;
                                     virtual ;
                                 procedure Set_Clipboard( Path, Value : string ) ;
                                     virtual ;
                                 function Max_File_Size : int64 ; virtual ;
                                 function Device_Manager : PSDevice_Manager ;
                                     virtual ;
                         end ;
     PSOS_Windows = ^TSOS_Windows ;

implementation

uses { Borland... }
     Windows, { TOSVersionInfo }
     Clipbrd, { Clipboard }
     Graphics, { TBitmap }
     Messages, { WM_CHAR }
     Printers, { Printer }
     Registry, { TRegistry }

     { Layer 0... }
     Common, { TObject }

     { Layer 1... }
     ASCIIDef, { NUL }
     CommonUt, { Edit }
     Compatib, { SetLength }
     DebugInt, { Static_Debug_Wrapper }
     OSWinDeb ; { TMS_Windows_Debugger }

(*
procedure MSDOS( var Regs : TRegisters ) ;

begin
    asm
        PUSH EBP ;
        PUSH ESI ;
        PUSH EDI ;

        MOV AX, Regs._AX ;
        MOV BX, Regs._BX ;
        MOV CX, Regs._CX ;
        MOV DX, Regs._DX ;
        MOV BP, Regs._BP ;
        MOV SI, Regs._SI ;
        MOV DI, Regs._DI ;
        PUSH Regs.Flags ;
        POPF ;
        INT $21 ;
        PUSHF ;
        POP Regs.Flags ;
        MOV Regs._DI, DI ;
        MOV Regs._SI, SI ;
        MOV Regs._BP, BP ;
        MOV Regs._DX, DX ;
        MOV Regs._CX, CX ;
        MOV Regs._BX, BX ;
        MOV Regs._AX, AX ;

        POP EDI ;
        POP ESI ;
        POP EBP ; { Pop EBP }
    end ;
end ;
*)

{ TOS_Device_Manager... }

type TOS_Device_Manager = object( TSDevice_Manager )
                              public { API... }
                                  function Disk_Clusters( Drive : string ) : int64 ;
                                      virtual ;
                                  { Returns number of clusters on specified disk
                                    drive.  Returns -1 if an error or unknown. }

                                  function Disk_Sector_Size( Drive : string ) : longint ;
                                      virtual ;
                                  { Returns size of disk sectors, in bytes.
                                    Returns -1 if an error or unknown. }

                                  function Fixed_Device( Device : string ) : boolean ;
                                      virtual ;
                                  { Returns true if the passed device is fixed
                                    (non-removable) }

                                  function Max_Filename_Length( Device : string ) : longint ;
                                      virtual ;
                                      
                                  function Media_ID( Device : string ) : longint ;
                                      virtual ;
                                  { Return type of media in/on device.  -1 if
                                    error or unknown. }

                                  function Valid_Device( Device : string ) : boolean ;
                                      virtual ;
                                  { Returns true if the passed device is valid. }
                          end ;
     POS_Device_Manager = ^TOS_Device_Manager ;


{ API... }

function TOS_Device_Manager.Disk_Clusters( Drive : string ) : int64 ;

begin
    Disk_Clusters := -1 ;
end ;


function TOS_Device_Manager.Disk_Sector_Size( Drive : string ) : longint ;

begin
    Disk_Sector_Size := -1 ;
end ;


function TOS_Device_Manager.Fixed_Device( Device : string ) : boolean ;

begin
    Fixed_Device := False ;
    if(
        ( length( Device ) = 0 )
        or
        ( ( length( Device ) > 1 ) and ( Device[ 2 ] <> ':' ) )
      ) then
    begin
        exit ;
    end ;

    case GetDriveType( PChar( copy( Device, 1, 2 ) + '\' ) ) of
        DRIVE_FIXED: Result := True ;
    end ;
end ;


function TOS_Device_Manager.Max_Filename_Length( Device : string ) : longint ;

begin
    Result := -1 ;
    if(
        ( length( Device ) = 0 )
        or
        ( ( length( Device ) > 1 ) and ( Device[ 2 ] <> ':' ) )
      ) then
    begin
        exit ;
    end ;
    Result := 255 ;
end ;


function TOS_Device_Manager.Media_ID( Device : string ) : longint ;

var Typ : integer ;

begin
    Media_ID := -1 ;
    if(
        ( length( Device ) = 0 )
        or
        ( ( length( Device ) > 1 ) and ( Device[ 2 ] <> ':' ) )
      ) then
    begin
        exit ;
    end ;

    Typ := GetDriveType( PChar( copy( Device, 1, 2 ) + '\' ) ) ;
    case Typ of
        DRIVE_REMOVABLE: Result := $F0 ;
        DRIVE_FIXED: Result := $F8 ;
        DRIVE_REMOTE: Result := DRIVE_REMOTE ;
        DRIVE_CDROM: Result := DRIVE_CDROM ;
        DRIVE_RAMDISK: Result := DRIVE_RAMDISK ;
    end ;
end ;


function TOS_Device_Manager.Valid_Device( Device : string ) : boolean ;

begin
    Valid_Device := False ;
end ;



{ TOS_Windows methods... }

{ Constructors and destructors... }

constructor TSOS_Windows.Init ;

begin
    inherited Init ;

    Initialize( Input_Buffer ) ;
    Initialize( Internal_Clipboard ) ;
    _Device_Manager := nil ;
end ;


destructor TSOS_Windows.Done ;

begin
    _Device_Manager.Free ;
    _Device_Manager := nil ;

    inherited Done ;
end ;


{ API... }

function TSOS_Windows.Name : string ; { O/S name }

var X : TOSVersionInfo ;

begin
    X.dwOSVersionInfoSize := sizeof( X ) ;
    GetVersionEx( X ) ;
    case X.dwPlatformId of
        VER_PLATFORM_WIN32s:
            if( Version = '4.0' ) then
            begin
                Name := 'Windows 95' ;
            end else
            if( Version = '4.01' ) then
            begin
                Name := 'Windows 95B OSR2' ;
            end else
            if( Version = '4.1' ) then
            begin
                Name := 'Windows 98' ;
            end else
            if( Version = '4.9' ) then
            begin
                Name := 'Windows ME' ;
            end else
            begin
                Name := 'Windows' ;
            end ;
        VER_PLATFORM_WIN32_NT:
            if( Version = '5.0' ) then
            begin
                Name := 'Windows 2000' ;
            end else
            if( Version = '5.1' ) then
            begin
                Name := 'Windows XP' ;
            end else
            if( Version = '5.2' ) then
            begin
                Name := 'Windows 2003' ;
            end else
            begin
                Name := 'Windows NT' ;
            end ;
        else Name := 'WIN32' ;
    end ;
end ; // TOS_Windows.Name


function TSOS_Windows.Version : string ; { O/S version }

var X : TOSVersionInfo ;

begin
    X.dwOSVersionInfoSize := sizeof( X ) ;
    GetVersionEx( X ) ;
    case X.dwPlatformId of
        VER_PLATFORM_WIN32s: Version := '3.1' ;
        VER_PLATFORM_WIN32_WINDOWS,
            VER_PLATFORM_WIN32_NT: Version := inttostr( X.dwMajorVersion ) + '.' + inttostr( X.dwMinorVersion ) ;
        else Version := '' ;
    end ;
end ;


function TSOS_Windows.Application_Path : string ;

var Dummy : integer ;
    S : string ;

begin
    S := Paramstr( 0 ) ;
    Dummy := length( S ) ;
    while( S[ Dummy ] <> '\' ) do
    begin
        dec( Dummy ) ;
    end ;
    S := copy( S, 1, Dummy ) ;
    if( length( S ) = 0 ) then
    begin
        S := GetCurrentDir ;
    end ;
    Application_Path := S ;
end ;


procedure TSOS_Windows.Cancel_Typeahead ;

begin
    Input_Buffer := '' ;
{$IFDEF CONSOLE}
    FlushConsoleInputBuffer( GetStdHandle( STD_INPUT_HANDLE ) ) ;
{$ENDIF}

    inherited Cancel_Typeahead ;
end ;


function Parse_Parameter( Separator : string ; var Command : string ) : string ;
{ Return next parameter - have a local copy of this routine to ensure that this
  unit is initialized before any others that might reference it (Parse.pas
  includes too many other units). }

var Dummy : Integer ;
    Quote : Char ;

begin
    Quote := ' ' ; { No quote yet }
    if Length( Separator ) = 0 then Separator := ' ' ; { Default to space }
    for Dummy := 1 to Length( Command ) do
    begin
	if( Quote <> ' ' ) { if within a quote }
	    then
		if( Command[ Dummy ] = Quote ) then Quote := ' ' else
	    else { Not within a quote }
		if( ( Command[ Dummy ] = '"' ) or ( Command[ Dummy ] = Chr( 39 ) ) )
		    then Quote := Command[ Dummy ] ; { Check for quotes }
	if( Command[ Dummy ] = Separator[ 1 ] ) then if( Quote = ' ' ) then
	begin
	    Parse_Parameter := Copy( Command, 1, Dummy - 1 ) ; { Return parameter }
	    Command := Copy( Command, Dummy + 1, 255 ) ; { Strip from command line }
	    Exit ; { Done }
	end ;
    end ;
    { At this point, the entire command line is a parameter }
    Parse_Parameter := Command ; { Return next parameter }
    Command := '' ; { Strip from command line }
end ; { Parse_Parameter }


function TSOS_Windows.Command_Line : string ;

begin
    Result := GetCommandLine ;
    Parse_Parameter( ' ', Result ) ; { Trim program name }
end ;


{$IFDEF DELPHI}
function TSOS_Windows.Debugger : PSDebug_Interface ;

begin
  {$IFDEF Internals}
    Debugger := Static_Debug_Wrapper( TMS_Windows_Debugger.Create ) ;
  {$ELSE}
    Debugger := nil ;
  {$ENDIF}
end ;
{$ENDIF}


function TSOS_Windows.Get_Char( Wait : boolean ; var Valid : boolean ) : char ;

var Dummy : DWORD ;
{$IFDEF CONSOLE}
    Count : integer ;
    Handle : integer ;
    Input_Data : TInputRecord ;
{$ELSE}
    Msg : TMsg ;
{$ENDIF}

label Loop ;

begin
Loop:
{$IFDEF CONSOLE}
    Handle := GetStdHandle( STD_INPUT_HANDLE ) ;
    Get_Char := NUL ;
    GetNumberOfConsoleInputEvents( Handle, Dummy ) ;
    if( Wait ) then
    begin
        while( Dummy = 0 ) do
        begin
            GetNumberOfConsoleInputEvents( Handle, Dummy ) ;
        end ;
    end ;
    if( Dummy > 0 ) then
    begin
        { Get the data... }
        ReadConsoleInput( Handle, Input_Data, 1, Dummy ) ;
        if( Input_Data.EventType <> KEY_EVENT ) then
        begin
            goto Loop ;
        end ;

        Get_Char := Input_Data.Event.KeyEvent.AsciiChar ;

        { Handle repeats... }
        Count := Input_Data.Event.KeyEvent.wRepeatCount - 1 ;
        Dummy := length( Input_Buffer ) + Count ;
        setlength( Input_Buffer, Dummy ) ;
        while( Count > 0 ) do
        begin
            Input_Buffer[ Dummy ] := Result ;
            dec( Dummy ) ;
            dec( Count ) ;
        end ;
    end ;
{$ELSE}
    if( length( Input_Buffer ) > 0 ) then
    begin
        Get_Char := Input_Buffer[ 1 ] ;
        Input_Buffer := copy( Input_Buffer, 2, length( Input_Buffer ) ) ;
        exit ;
    end ;
    if( PeekMessage( Msg, 0, WM_KEYFIRST, WM_KEYLAST, PM_REMOVE ) ) then
    begin
        if( ( Msg.Message <> WM_CHAR ) and ( Msg.Message <> WM_SYSCHAR ) ) then
        begin
            TranslateMessage( Msg ) ;
            goto Loop ;
        end ;
        Msg.LParam := ( Msg.LParam and $FFFF ) - 1 ; // Mask off the count
        Get_Char := chr( Msg.WParam ) ;

        // Handle repeats...
        Dummy := length( Input_Buffer ) + Msg.LParam ;
        setlength( Input_Buffer, Dummy ) ;
        while( Msg.LParam > 0 ) do
        begin
            Input_Buffer[ Dummy ] := chr( Msg.WParam ) ;
            dec( Dummy ) ;
            dec( Msg.LParam ) ;
        end ;

        exit ;
    end else
    begin
        Application.ProcessMessages ;
    end ;

    { No input waiting }
    if( Wait ) then { Wait }
    begin
        goto Loop ;
    end ;
    Get_Char := NUL ;
{$ENDIF}
end ; // TOS_Windows.Get_Char


procedure TSOS_Windows.Beep( Typ : integer ) ;

begin
    MessageBeep( 0 ) ;
end ;


function TSOS_Windows.Get_Symbol( const X : string ) : string ;

var Y : array[ 0..127 ] of char ;

begin
    if( GetEnvironmentVariable( PChar( X ), Y, 127 ) = 0 ) then
    begin
        Get_Symbol := '' ; { Not defined }
    end else
    begin
        Get_Symbol := strpas( Y ) ;
    end ;
end ;


procedure TSOS_Windows.Get_Date( var Year, Month, Day : word ) ;

begin
    DecodeDate( Date, Year, Month, Day ) ;
end ;


procedure TSOS_Windows.Get_Time( var Hour, Minute, Second, Hundreths : word ) ;

begin
    DecodeTime( Time, Hour, Minute, Second, Hundreths ) ;
end ;


function TSOS_Windows.Pending_Input : boolean ;

var Msg : TMsg ;

begin
    Application.ProcessMessages ;
    Pending_Input := PeekMessage( Msg, 0, WM_CHAR, WM_CHAR, PM_NOREMOVE ) ;
end ;


function TSOS_Windows.PID : longint ;

begin
    PID := GetCurrentProcessId ;
end ;


procedure TSOS_Windows.Print( T : string ) ;

var Dummy : integer ;
    H, I : integer ;

begin
    Printer.BeginDoc ;
    I := 0 ;
    H := Printer.Canvas.TextHeight( T ) ;
    while( length( T ) > 0 ) do
    begin
        Dummy := pos( CR, T ) ;
        if( Dummy = 0 ) then
        begin
            Dummy := length( T ) + 1 ;
        end ;

        Printer.Canvas.TextOut( 0, I, copy( T, 1, Dummy - 1 ) ) ;
        T := copy( T, Dummy + 1, length( T ) ) ;
        I := I + H ;
    end ;
    Printer.EndDoc ;
end ;


procedure TSOS_Windows.Last_Error( var UEC : TUEC ) ;

begin
    UEC.Facility := 0 ; { Windows }
    UEC.Code := GetLastError ;
end ;


function TSOS_Windows.Error_Text( const UEC : TUEC ;
    const Language : string ) : string ;

var Dummy : integer ;
    S : string ;

begin
    if( UEC.Facility = 0 ) then
    begin
        //TODO: Convert passed Language to a language ID
        setlength( S, 255 ) ;
        FormatMessage( FORMAT_MESSAGE_ALLOCATE_BUFFER or FORMAT_MESSAGE_FROM_SYSTEM,
            nil, UEC.Code, 0, @S[ 1 ], length( S ), nil ) ;
        Dummy := pos( #0, S + #0 ) ;
        Error_Text := copy( S, 1, Dummy - 1 ) ;
    end else
    begin
        Error_Text := '' ;
    end ;
end ;


function TSOS_Windows.Get_Temp_Path : string ;

var Res : string ;

begin
    SetLength( Res, 255 ) ;
    SetLength( Res, GetTempPath( length( Res ), @Res[ 1 ] ) ) ;
end ;


function TSOS_Windows.System_Path : string ;

var Buffer : array[ 0..MAX_PATH ] of char ;
    L : integer ;

begin
    L := GetSystemDirectory( Buffer, sizeof( Buffer ) ) ;
    setlength( Result, L ) ;
    move( Buffer[ 0 ], PChar( Result )^, L ) ;
end ;


function TSOS_Windows.Swap_File_List : string ;

var Buffer : array[ 0..32767 ] of char ;
    Dir, Nam, S, Temp, Work : string ;
    Dummy : integer ;
    Reg : TRegistry ;

begin
    S := '' ;
    if( copy( Version, 1, 1 ) < '5' ) then // Windows 95/98/ME
    begin
	Dummy := GetSystemDirectory( @Buffer, 32767 ) ;
        setlength( Dir, Dummy ) ;
        move( Buffer, PChar( Dir )[ 0 ], Dummy ) ;
        Dummy := length( Dir ) - 1 ;
        while( ( Dummy > 0 ) and ( Dir[ Dummy ] <> '\' ) ) do // Find parent of system directory
        begin
            dec( dummy ) ;
        end ;
        Dir := copy( Dir, 1, Dummy ) ;
        Nam := Dir + 'system.ini' ;
        if( GetPrivateProfileString( '386enh', 'PagingFile', '', @Buffer, 32767, PChar( Nam ) ) > 0 ) then
        begin
            S := strpas( Buffer ) ;
            if( copy( S, 2, 1 ) <> ':' ) then // Missing a drive specification
            begin
                if( GetPrivateProfileString( '386enh', 'PagingDrive', '', @Buffer, 32767, PChar( Nam ) ) > 0 ) then
                begin
                    S := Buffer[ 0 ] + ':' + S ;
                end else
                begin
                    S := copy( Nam, 1, 2 ) + S ; // Use default drive
                end ;
            end ;
        end else
        if( GetPrivateProfileString( '386enh', 'PagingDrive', '', @Buffer, 32767, PChar( Nam ) ) > 0 ) then
        begin
            S := Buffer[ 0 ] + ':\win386.swp' ;
        end else
        begin
            S := Dir + 'win386.swp' ;
        end ;
    end else
    begin
        // Windows NT/2000/XP...
        Reg := TRegistry.Create ;
        try
            Reg.RootKey := HKEY_LOCAL_MACHINE ;
            Reg.OpenKeyReadOnly( 'SYSTEM\CurrentControlSet\Control\Session Manager\Memory Management' ) ;
            if( Reg.ValueExists( 'PagingFiles' ) ) then
            begin
                try
                    { TRegistry doesn't read REG_MULTI_SZ as a string (gives an
                      exception), so we have to read it as Binary. }
                    Dummy := Reg.ReadBinaryData( 'PagingFiles', Buffer, 32767 ) ;
                    setlength( S, Dummy - 1 ) ;
                    move( Buffer, PChar( S )[ 0 ], Dummy - 1 ) ;
                except
                    try
                        S := Reg.ReadString( 'PagingFiles' ) ; // Just in case they change the above behavior
                    except
                        S := Dir + 'Pagefile.sys' ;
                    end ;
                end ;
                Dummy := pos( NUL, S ) ;
                while( Dummy > 0 ) do
                begin
                    S[ Dummy ] := ';' ;
                    Dummy := pos( NUL, S ) ;
                end ;
                Temp := S ;
                S := '' ;
                while( length( Temp ) > 0 ) do
                begin
                    Dummy := pos( ';', Temp + ';' ) ;
                    Work := copy( Temp, 1, Dummy - 1 ) ;
                    Temp := copy( Temp, Dummy + 1, length( Temp ) ) ;
                    Dummy := pos( ' ', Work + ' ' ) ;
                    if( length( S ) > 0 ) then
                    begin
                        S := S + ';' ;
                    end ;
                    S := S + copy( Work, 1, Dummy - 1 ) ;
                end ;
            end else
            begin
                S := Dir + 'Pagefile.sys' ;
            end ;
        finally
            Reg.Free ;
        end ;
    end ;
    Swap_File_List := S ;
end ; // TOperating_System.Swap_File_List


procedure TSOS_Windows.Spawn( const Path, Parameters : string ) ;

var a, b : array[ 0..255 ] of char ;

begin
    strpcopy( a, Path ) ;
    strcat( a, ' ' ) ;
    strpcopy( b, Parameters ) ;
    strcat( a, b ) ;
    WinExec( @a, SW_SHOW ) ;
end ;


function TSOS_Windows.Timestamp : int64 ;

begin
    Timestamp := 0 ;
end ;


function TSOS_Windows.Get_Clipboard( Path : string ) : string ;

var Handle : THandle ;
    P : pointer ;
    
begin
    if( Path = '' ) then
    begin
        Get_Clipboard := Internal_Clipboard ;
        exit ;
    end ;
    Path := Edit( Path, -1 ) ;
    if( Path = 'TEXT' ) then
    begin
        Get_Clipboard := Clipboard.AsText ;
        exit ;
    end ;
    if( Path = 'RTF' ) then
    begin
        if( not Clipboard.HasFormat( CF_TEXT ) ) then
        begin
            Get_Clipboard := '' ;
            exit ;
        end ;

        OpenClipboard( Application.MainForm.Handle ) ;
        try
            Handle := GetClipboardData( RegisterClipboardFormat( 'Rich Text Format' ) ) ;
            if( Handle = 0 ) then
            begin
                Get_Clipboard := '' ;
                exit ;
            end ;

            setlength( Result, GlobalSize( Handle ) ) ;
            try
                P := GlobalLock( Handle ) ;
                try
                    move( P^, PChar( Result )^, length( Result ) ) ;
                finally
                    GlobalUnlock( Handle ) ;
                end ;
            except
                GlobalFree( Handle ) ;
            end ;
        finally
            CloseClipboard ;
        end ;
        exit ;
    end ;
    if( Path = 'BITMAP' ) then
    begin
        if( not Clipboard.HasFormat( CF_BITMAP ) ) then
        begin
            Get_Clipboard := '' ;
            exit ;
        end ;

        OpenClipboard( Application.MainForm.Handle ) ;
        try
            Handle := GetClipboardData( CF_BITMAP ) ;
            if( Handle = 0 ) then
            begin
                Get_Clipboard := '' ;
                exit ;
            end ;

            setlength( Result, GlobalSize( Handle ) ) ;
            try
                P := GlobalLock( Handle ) ;
                try
                    move( P^, PChar( Result )^, length( Result ) ) ;
                finally
                    GlobalUnlock( Handle ) ;
                end ;
            except
                GlobalFree( Handle ) ;
            end ;
        finally
            CloseClipboard ;
        end ;
        exit ;
    end ;
    Get_Clipboard := '' ;
end ; { TSOS_Windows.Get_Clipboard }


procedure TSOS_Windows.Set_Clipboard( Path, Value : string ) ;

var Handle : THandle ;
    P : pointer ;

begin
    if( Path = '' ) then
    begin
        Internal_Clipboard := Value ;
        exit ;
    end ;
    if( Path = 'TEXT' ) then
    begin
        Clipboard.AsText := Value ;
        exit ;
    end ;
    if( Path = 'RTF' ) then
    begin
        OpenClipboard( Application.MainForm.Handle ) ;
        try
            Handle := GlobalAlloc( GMEM_MOVEABLE, length( Value ) + 1 ) ;
            try
                P := GlobalLock( Handle ) ;
                try
                    move( PChar( Value )^, P^, length( Value ) + 1 ) ;
                    SetClipboardData( RegisterClipboardFormat( 'Rich Text Format' ), Handle ) ;
                finally
                    GlobalUnlock( Handle ) ;
                end ;
            except
                GlobalFree( Handle ) ;
            end ;
        finally
            CloseClipboard ;
        end ;
        exit ;
    end ;
    if( Path = 'BITMAP' ) then
    begin
        OpenClipboard( Application.MainForm.Handle ) ;
        try
            Handle := GlobalAlloc( GMEM_MOVEABLE, length( Value ) + 1 ) ;
            try
                P := GlobalLock( Handle ) ;
                try
                    move( PChar( Value )^, P^, length( Value ) + 1 ) ;
                    SetClipboardData( CF_BITMAP, Handle ) ;
                finally
                    GlobalUnlock( Handle ) ;
                end ;
            except
                GlobalFree( Handle ) ;
            end ;
        finally
            CloseClipboard ;
        end ;
        exit ;
    end ;
end ; { TSOS_Windows.Set_Clipboard }


function TSOS_Windows.Max_File_Size : int64 ;

begin
    Max_File_Size := $3FFFFFFF ;
end ;


function TSOS_Windows.Device_Manager : PSDevice_Manager ;

begin
    if( _Device_Manager = nil ) then
    begin
        _Device_Manager := new( POS_Device_Manager, Init ) ;
    end ;
    Device_Manager := _Device_Manager ;
end ;


end.
