{
        Program Name : Common
        Package Name : LB
        Purpose      : Common base objects (TBase_Object and TBase_Delphi_Object)
        Institution  : Conroy & Conroy Co.
        Date Written : 19-Feb-2005
        Written By   : Alan Conroy
        Version      : 1.0

	Copyright (C) 2005 by Alan Conroy.  Released to the public domain.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *    DATE        BY          REASON                         *
        *                                                           *
        *************************************************************

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

}

unit ObjectFa ;

interface

{$I EDEFINES.INC}

uses { Layer 0... }
     _Propert, { PSDynamic_Properties }
     _ObjectF ; { PSObject_Factory }

implementation

uses { Layer 1... }
     DPropert, { PSStandard_Dynamic_Properties }
     _GenVal, { PSGeneric_Value }
     GenVal ; { PSSimple_Generic_Value }

type TSDefault_Object_Factory = object( TSObject_Factory )
                                    public
                                        function Static_Dynamic_Properties : PSDynamic_Properties ;
                                            virtual ;
{$IFDEF DELPHI}
                                        function COM_Dynamic_Properties : TCOM_Dynamic_Properties ;
                                            virtual ;
                                        function Dynamic_Properties : TDynamic_Properties ;
                                            virtual ;
{$ENDIF}
                                        function Static_Generic_Value : PSGeneric_Value ;
                                            virtual ;
{$IFDEF DELPHI}
                                        function COM_Generic_Value : TCOM_Generic_Value ;
                                            virtual ;
                                        function Generic_Value : TGeneric_Value ;
                                            virtual ;
{$ENDIF}
                                end ;
     PSDefault_Object_Factory = ^TSDefault_Object_Factory ;

function TSDefault_Object_Factory.Static_Dynamic_Properties : PSDynamic_Properties ;

begin
    Static_Dynamic_Properties := new( PSStandard_Dynamic_Properties, Init ) ;
end ;


{$IFDEF DELPHI}
function TSDefault_Object_Factory.COM_Dynamic_Properties : TCOM_Dynamic_Properties ;

begin
    COM_Dynamic_Properties := TStandard_COM_Dynamic_Properties.Create ;
end ;


function TSDefault_Object_Factory.Dynamic_Properties : TDynamic_Properties ;

begin
    Dynamic_Properties := TStandard_Dynamic_Properties.Create ;
end ;
{$ENDIF}


function TSDefault_Object_Factory.Static_Generic_Value : PSGeneric_Value ;

begin
    Static_Generic_Value := new( PSSimple_Generic_Value, Init ) ;
end ;


{$IFDEF DELPHI}
function TSDefault_Object_Factory.COM_Generic_Value : TCOM_Generic_Value ;

begin
    COM_Generic_Value := TCOM_Simple_Generic_Value.Create ;
end ;


function TSDefault_Object_Factory.Generic_Value : TGeneric_Value ;

begin
    Generic_Value := TSimple_Generic_Value.Create ;
end ;
{$ENDIF}



begin
    Object_Factory := new( PSDefault_Object_Factory, Init ) ;
end.
