{
        Program Name : Soundx
        Package Name : LB
        Purpose      : Convert strings to Soundex code
        Institution  : Conroy & Conroy Co.
        Date Written : 15-Jun-1998
        Written By   : Alan Conroy
        Version      : 1.0

        Copyright (C) 1998 by Alan Conroy.  Released to the public domain.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *    DATE        BY          REASON                         *
        *                                                           *
        *                                                           *
        *************************************************************

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

	  Soundex converts a string into a Soundex code.
}

unit Soundx ;

interface

function Soundex( X : string ) : string ;

implementation

uses CommonUt ; { Edit }

function Soundex( X : string ) : string ;

var C : string ;
    Dummy : integer ;
    S : string ;

begin
    { Setup... }
    X := Edit( X, 32 ) ;
    while(
	   ( length( X ) > 0 )
	   and
	   ( pos( X[ 1 ], 'ABCDEFGHIJKLMNOPQRSTUVWXYZ' ) = 0 )
	 ) do
    begin
	X := copy( X, 2, length( X ) ) ;
    end ;

    { Convert... }
    S := copy( X, 1, 1 ) ;
    X := copy( X, 2, length( X ) ) ;
    while( ( X[ 1 ] = S ) and ( length( X ) > 0 ) ) do
    begin
	X := copy( X, 2, length( X ) ) ;
    end ;
    C := copy( '01230120022455012623010202', ord( S[ 1 ] ) - 64, 1 ) ;
    while(
	   ( C = copy( '01230120022455012623010202', ord( X[ 1 ] ) - 64, 1 ) )
	   and
	   ( length( X ) > 0 )
	   and
	   ( C <> '0' )
	 ) do
    begin
	X := copy( X, 2, length( X ) ) ;
    end ;
    Dummy := 1 ;
    while( Dummy <= length( X ) ) do
    begin
	if( pos( X[ Dummy ], 'BCDFGJKLMNPQRSTVXZ' ) = 0 ) then
	begin
	    X := copy( X, 1, Dummy - 1 ) + copy( X, Dummy + 1, length( X ) ) ;
	end else
	begin
	    inc( Dummy ) ;
	end ;
    end ;
    while( ( length( X ) > 0 ) and ( length( S ) < 4 ) ) do
    begin
	C := copy( '01230120022455012623010202', ord( X[ 1 ] ) - 64, 1 ) ;
	if( C <> S[ length( S ) ] ) then
	begin
	    S := S + C ;
	end ;
	X := copy( X, 2, 3 ) ;
    end ;
    while( length( S ) < 4 ) do
    begin
	S := S + '0' ;
    end ;
    Soundex := S ;
end ;



end.
