{
        Program Name : Structex
        Package Name : LB
        Purpose      : Structure Text object
        Institution  : Conroy & Conroy Co.
        Date Written : 2-September-2003
        Written By   : Alan Conroy
        Version      : 1.0

	Copyright (C) 2003 by Alan Conroy.  All rights reserved.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *    DATE        BY          REASON                         *
        *                                                           *
        *                                                           *
        *************************************************************

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

          TStructured_Text supports structured text such as SGML.
}

unit Structex ;

interface

uses { C&C... }
     Common, { TObject }
     Outlines ; { POutline }

type TStructured_Text = object( TObject )
                            public { Constructors and destructors... }
                                constructor Init ;
                                destructor Done ; virtual ;

                            private { Instance data... }
                                _Outline : PSOutline ;
                                _Position : PSOutline_Node ;

                            private { Internal utility routines... }
                                function Create_Node_At_Position : PSOutline_Node ;

                            public { API... }
                                procedure Add_Section( Source : PString ) ;
                                    virtual ;
                                { Add a section to the end of the text }

                                procedure Add_Tag( const Tag : string ) ; virtual ;
                                { Add a tag to the end of the text }

                                procedure Add_Text( const Source : string ) ;
                                    virtual ;
                                { Add text to the end of the text }

                                procedure End_Section( const Tag : string ) ;
                                    virtual ;
                                { End a section started with Start_Section }

                                procedure Clear ; virtual ;
                                { Delete all text }

                                function Get_Section : PString ; virtual ;
                                {}

                                procedure Load( Source : PString ) ; virtual ;
                                { Load text from source }

                                procedure Start_Section( const Tag : string ) ;
                                    virtual ; { Start a section }
                        end ;
     PStructured_Text = ^TStructured_Text ;

implementation

type TSegment_Type = ( ST_Text, { Text }
                       ST_Tag, { Tag }
                       ST_Nest_End, { Nested section end }
                       ST_Nest_Start { Nested section start }
                     ) ;
     TSegment = object( TObject )
                    public
                        Typ : TSegment_Type ;
                        Text : PString ;

                        constructor Init ;
                        destructor Done ; virtual ;
                end ;
     PSegment = ^TSegment ;

{ TSegment methods... }

constructor TSegment.Init ;

begin
    inherited Init ;

    Text := nil ;
    Typ := ST_Undefined ;
end ;


destructor TSegment.Done ;

begin
    if( Text <> nil ) then
    begin
        dispose( Text, Done ) ;
        Text := nil ;
    end ;

    inherited Done ;
end ;


{ TStructured_Text methods... }

{ Constructors and destructors... }

constructor TStructured_Text.Init ;

begin
    inherited Init ;

    _Outline := new( PSOutline, Init ) ;
    _Position := nil ;
end ;


destructor TStructured_Text.Done ;

begin
    dispose( _Outline, Done ) ;

    inherited Done ;
end ;


{ Internal utility routines... }

function TStructured_Text.Create_Node_At_Position : PSOutline_Node ;

begin

end ;


{ API... }

procedure TStructured_Text.Add_Section( Source : PString ) ;

var Node : PSOutline_Node ;

begin
    Node := Create_Node_At_Position ;
    {~~~}
end ;


procedure TStructured_Text.Add_Tag( const Tag : string ) ;

begin
end ;


procedure TStructured_Text.Add_Text( const Source : string ) ;

begin
end ;


procedure TStructured_Text.End_Section( const Tag : string ) ;

begin
end ;


procedure TStructured_Text.Clear ;

begin
    _Outline.Clear ;
end ;


function TStructured_Text.Get_Section : PString ;

begin
end ;


procedure TStructured_Text.Load( Source : PString ) ;

begin
    Clear ;
    Add_Section( Source ) ;
end ;


procedure TStructured_Text.Start_Section( const Tag : string ) ;

begin

end ;


end.
