/*
        Program Name : TArray_Interface
        Package Name : LB
        Purpose      : Abstract virtual array interface class
        Institution  : Conroy & Conroy Co.
        Date Written : 27-March-2001
        Written By   : Alan Conroy
        Version      : 1
        Revision     : 0
        Edit         :

	Copyright (C) 2001 by Alan Conroy.  Released to the public domain.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *    DATE        BY          REASON                         *
        *                                                           *
        *                                                           *
        *************************************************************

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

*/

#include "COMInter.h"

class TArray_Interface : TCommon_COM_Interface
{
      public: // API...
          // TArray_Interface version 0 interface:

          // Return a byte from the given index.
          virtual __stdcall char function Get_Byte( int64 Index ) = 0;

          // Set a byte at a specific index.
          virtual __stdcall Set_Byte( int64 Index, char Value ) = 0;

          // Returns true if the data is read-only.
          virtual __stdcall bool Read_Only() = 0;

          // Returns low bound of specified subscript.
          virtual __stdcall Low_Bound( int Subscript ) = 0;

          // Returns high bound of specified subscript.
          virtual __stdcall int64 High_Bound( int Subscript ) = 0;

          // Returns number of subscripts.
          virtual __stdcall int Subscripts() = 0;

          // Version 1 interface:
          // Nothing yet defined
} ;

