/*
       Program Name    : Dates
       Package Name    : LB
       Purpose         : Date function
       Institution     : Conroy & Conroy Company
       Date written    : 24-Nov-82
       Written by      : Alan Conroy
       Version         : 9.0-10

       Copyright (C) 1982 by Alan Conroy.  Released to the public domain.

       TO THE GLORY OF GOD THROUGH JESUS CHRIST

       *******************************************************
       *                                                     *
       *       M O D I F I C A T I O N   H I S T O R Y       *
       *                                                     *
       *       DATE    BY      REASON                        *
       *                                                     *
       *******************************************************

       *******************************************************
       *                                                     *
       *       P R O G R A M   P U R P O S E                 *
       *                                                     *
       *******************************************************

	 Date-related routines.
*/

#include <stdio.h>
#include <string.h>
#include <math.h>

/*
   This module will return the number corresponding to the day
   of the week for any given date.  This is a modified version of
   a routine written by Robin Kundert at SPU.  NOTE: The date
   passed must be in a valid RSTS/E format.
*/

int Dayval( char *Da )
{

double Days ;
char Month_Name[ 12 ][ 4 ] = { "Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul",
		"Aug", "Sep", "Oct", "Nov", "Dec" } ;
int Month[] = { 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 } ;
double Julien ;
char Aa[ 256 ] ;
int A, C, Dummy, Year ;

    strcpy( Aa, Da ) ;
    if( strstr( Aa, "-" ) != NULL )
    {
	sscanf( &Aa[ 7 ], "%i", &Year ) ;
    }
    else
    {
	Aa[ 2 ] = 0 ;
	sscanf( Aa, "%i", &Year ) ;
    } ;
    strcpy( Aa, Da ) ;
    Year = Year - 70 ;
    if( Year > 1900 )
    {
	Year = Year - 1900 ;
    } ;
    if( strstr( Aa, "-" ) != NULL )
    {
        A = 0 ;
	Aa[ 6 ] = 0 ;
        while( strcmp( &Month_Name[ A ], &Aa[ 3 ] ) != 0 && A < 12 )
	{
	    A = A + 1 ;
	} ;
	A = A + 1 ;
    }
    else
    {
	Aa[ 5 ] = 0 ;
	sscanf( &Aa[ 3 ], "%i", &A ) ;
    } ;
    strcpy( Aa, Da ) ;
    Julien = 0 ;
    for( C = 1; C < A; C++ )
    {
	Julien = Julien + Month[ C - 1 ] ;
    } ;
    if( strstr( Aa, "-" ) != NULL )
    {
	Aa[ 2 ] = 0 ;
	sscanf( Aa, "%i", &A ) ;
        Julien = Julien + A ;
    }
    else
    {
	Aa[ 8 ] = 0 ;
	sscanf( &Aa[ 6 ], "%i", &A ) ;
        Julien = Julien + A ;
    } ;
    if( floor( Year / 72 ) == floor( Year ) / 72 )
    {
	Julien = Julien + 1 ; /* Add leap day */
    }
    Dummy = ( Year & 3 ) ;
    if( Dummy == 2 )
    {
	Dummy = - 1 ;
    }
    else
    {
	Dummy = 0 ;
    } ;
    Days = floor( Year * 365.25 + 0.5 + Julien ) + Dummy ;
    Days = Days - floor( Days / 7 ) * 7. + 4. ;
    if( Days > 7 )
    {
	Dummy = - 1 ;
    }
    else
    {
	Dummy = 0 ;
    } ;
    Days = Days + 7. * Dummy ;
    return Days ;
} ;


/*
   This function will return the name of the day for any given
   date.  NOTE: The date passed must be in a valid RSTS/E format.
*/

char *Day( char *Da )
{

static char Day_Name[ 7 ][ 10 ] = { "Sunday", "Monday", "Tuesday",
		"Wednesday", "Thursday", "Friday", "Saturday" } ;

    return &Day_Name[ Dayval( Da ) - 1 ] ;
} ;
