type TStore_Address = int64 ;

     TDirectory_Entry = record
                            Name : string[ FS_Maximum_File_Name ] ;
                            Version : smallint ; { 1-65535 }
                            Version_Limit : smallint ; { 1-65535 }
                            Size : TStore_Address ;
                            Owner : longint ; { User ID }
                            Created_By : longint ; { User ID }
                            Creation_Time : longint ;
                            Creation_Date : longint ;
                            Revision_Time : longint ;
                            Revision_Date : longint ;
                            Access_Time : longint ;
                            Access_Date : longint ;
                            Expiration_Time : longint ;
                            Expiration_Date : longint ;
                            Protection : longint ;
                            Attributes : longint ; { FSFF flags }
                            Extension : TStore_Address ; { Bytes to extend by }
                            End_Of_File : TStore_Address ;
                            Record_Size : TStore_Address ;
                            Uncompressed_Size : TStore_Address ;
                            ACL : TStore_Address ;
                            Properties : TStore_Address ; { Pointer to property data }
                            Methods : TStore_Address ; { Pointer to method data }  
                            Allocation_Info : TStore_Address ;
                            { Pointer to allocation list for file.  For
                              directories: pointer to L/R records for files
                              in the directory. }

                            Next_Alpha_Entry : TStore_Address ;
                            Left_Pointer : TStore_Address ; { < pointer }
                            Right_Pointer : TStore_Address ; { > pointer }
                            Back_Pointer : TStore_Address ; { Father node pointer }
                            Reserved : array[ 0..9 - sizeof( TStore_Address ) ] of byte ;
		        end ; { TDirectory_Entry }

     TFile_Property = record
                          Name : string[ 63 ] ; { Name of property }
                          { Reserved properties: $Caching_Info, $Access_Info, $Auditing_Info, $Access_Stats }
                          Protection : longint ;
				  ACL : TStore_Address ;
                          Size : longint ; { Size of data, in bytes }
				  Data : ~~~ ;
                          Extended_Data : TStore_Address ;
                          Next : TStore_Address ; { Pointer to next property (0 if end) }
                          Reserved : array[ 0..7 ] of byte ;
                      end ; { TFile_Property }

     TFile_Method = record
                          Name : string[ 63 ] ; { Name of method }
                          { Reserved properties: $Open_File, $File_Properties, $Read_File, $Write_File }
                          Protection : longint ;
				  ACL : TStore_Address ;
				  Data : string[ 127 ] ; { Program name/parameters for method invocation }
                          Next : TStore_Address ; { Pointer to next method (0 if end) }
                          Reserved : array[ 0..7 ] of byte ;
                      end ; { TFile_Property }
