/*
              Program Name : HELP
              Package Name : LB
              Purpose      : General-purpose help routine
              Institution  : Conroy & Conroy
              Date Written : 18-Aug-88
              Written By   : Alan Conroy
              Version      : 1.0

              Copyright (C) 1988 by Alan Conroy.  Released to the public domain.

              TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *********************************************************
        *                                                       *
        *        M O D I F I C A T I O N   H I S T O R Y        *
        *                                                       *
        *     DATE      BY             REASON                   *
        *                                                       *
        *********************************************************

        *********************************************************
        *                                                       *
        *           P R O G R A M   P U R P O S E               *
        *                                                       *
        *********************************************************

          This procedure provides help from .HLP files.
*/

#include <stdio.h>
#include <string.h>

#include "clib.h"
#include "help.h"
#include "edit.h"
#include "files.h"
#include "getchars.h"
#include "instr.h"

static int Column ; /* Column count */
static int Dummy ; /* Dummy loop variable */
static int Header ; /* True if header displayed */
static FILE *Help_File ; /* Main help file */
static char Help_Files[ 40 ][ 32 ] ; /* Help filenames per level */
static int Help_Line[ 40 ] ; /* Line in help file for "*" */
static int Icf, T ;
static int Level ; /* Current help file level */
static int Line_Count ; /* Number of lines displayed on screen since last input */
static int Lr ; /* Count of lines read */
static char Partial[ 256 ] ;
static char Topic[ 256 ] ; /* Current topic */
static char Topics[ 40 ][ 256 ] ; /* Help topics per level */
static int Wildcard ;

static void Out( char *X ) /* Output a line of text */
{

int A ;

    if( X == NULL )
    {
	printf( "\n" ) ;
	goto Skip ;
    } ;
    if( strlen( X ) > 0 && X[ 0 ] == 12 )
    {
	Line_Count = 23 ; /* FF is end of screen */
    }
    else
    {
        if( strlen( X ) > 0 && Level > 1 )
	{
	    for( A = 2; A <= Level; A++ )
	    {
		printf( "  " ) ;
	    } ;
	} ;
        printf( "%s", X ) ;
        Line_Count = Line_Count + 1 ;
    } ;
Skip:
    if( Line_Count == 23 )
    {
        printf( "Press any key to continue..." ) ;
        Get_Char( 0 ) ;
        printf( "\r                            \r" ) ;
        Line_Count = 0 ;
    } ;
} ;


static void Further() /* Display subtopic names */
{

char Command[ 256 ] ;

    Column = 0 ;
    Header = False ;
    while( !feof( Help_File ) )
    {
        fgets( &Command, 256, Help_File ) ;
	if( feof( Help_File ) )
	{
	    continue ;
	} ;
        Lr = Lr + 1 ;
        if( Command[ 0 ] == '*' )
	{
            if( Command[ 1 ] != '|' )
            {
                if( !Header )
                {
                    Out( NULL ) ;
                    printf( "Further help is available on:" ) ;
                    Out( NULL ) ;
                    Out( NULL ) ;
                    Header = True ;
                } ;
                if( Column > 72 )
                {
                    Out( NULL ) ;
                    Column = 0 ;
                } ;
                while( ( Column & 7 ) != 0 )
                {
                    Column = Column + 1 ;
                    printf( " " ) ;
                } ;
		Edit( Command, Command, 4 ) ;
                Column = Column + strlen( Command ) ;
                if( Column > 79 )
                {
                    Out( NULL ) ;
                    Column = strlen( Command ) ;
                } ;
                printf( "%s ", &Command[ 1 ] ) ;
            } ;
	} ;
    } ;
    if( Header )
    {
	Out( NULL ) ;
    } ;
} ;


static int Print_Help( char *XX )
{
/* Display help for current topic - return TRUE if OK, FALSE if error */

char Command[ 256 ] ;
int Lc ; /* Lines printed, lines read count */
char Topic[ 256 ], Z[ 256 ] ;
char Temp1[ 256 ], Temp2[ 256 ], X[ 256 ] ;

    if( XX == NULL )
    {
	X[ 0 ] = 0 ;
    }
    else
    {
	strcpy( X, XX ) ; /* Make local copy of passed parameter string */
    } ;
Start:
    Icf = False ;
    rewind( Help_File ) ;
    Lr = 0 ;
    if( strlen( X ) == 0 ) /* Initial state */
    {
        while( !feof( Help_File ) )
        {
            fgets( &Z, 256, Help_File ) ;
	    if( feof( Help_File ) )
	    {
		continue ;
	    } ;
            Lr = Lr + 1 ;
            if( Z[ 0 ] == '*' )
	    {
		goto Prompt ;
	    } ;
            Out( Z ) ;
        } ;
        goto Prompt ;
    } ;
    Lc = Instr( 1, X, " " ) - 1 ;
    if( Lc < 0 )
    {
	Lc = strlen( X ) ;
    } ;
    strcpy( Topic, X ) ;
    X[ Lc - 1 ] = 0 ; /* Get topic */
    strcpy( &Topics[ Level ], Topic ) ;
    strcpy( X, &X[ Lc ] ) ; /* Get sub-topic(s) */
    Lc = 0 ; /* No lines thus far */
    if( strcmp( Topic, "*" ) == 0 ) /* If a wildcard */
    {
	if( Wildcard > Level )
	{
	    Wildcard = Level ;
	} ;
    } ;
Next_Line:
    if( feof( Help_File ) ) /* No match found */
    {
        if( strcmp( Topic, "*" ) != 0 )
        {
            printf( "Sorry, no help for %s found at this level.\n", Topic ) ;
	    return False ;
        } ;
        return True ;
    } ;
    fgets( &Z, 256, Help_File ) ;
    Lr = Lr + 1 ;
    Edit( Z, Z, 188 ) ;
    if( Z[ 0 ] != '*' )
    {
	goto Next_Line ;
    } ;
    strcpy( Temp1, "*" ) ;
    strcat( Temp1, Topic ) ;
    strcpy( Temp2, "*|" ) ;
    strcat( Temp2, Topic ) ;
    if( strcmp( Topic, "*" ) != 0 && strcmp( Z, Temp1 ) != 0 &&
	strcmp( Z, Temp2 ) != 0 )
    {
        goto Next_Line ;
    }
    if( Topic == '*' )
    {
	strcpy( &Topics[ Level ], &Z[ 1 ] ) ;
    } ;
    Out( &Topics[ Level ] ) ;
    Out( NULL ) ;
Next_Line1:
    while( !feof( Help_File ) ) /* Find and display text for this topic */
    {
        fgets( &Command, 256, Help_File ) ;
	if( feof( Help_File ) )
	{
	    continue ;
	} ;
        Lr = Lr + 1 ;
        if( Command[ 0 ] == '@' ) /* Indirect help */
        {
            if( Level == 40 )
            {
                printf( "%%Nesting exceeds 40 levels\n" ) ;
                return True ;
            } ;
            Icf = True ;
            strcpy( Command, &Command[ 1 ] ) ; /* Strip @ */
	    Edit( Command, Command, 4 ) ;
            if( strstr( Command, "." ) == NULL )
	    {
		strcat( Command, ".HLP" ) ; /* Default extension is .HLP */
	    } ;
            if( strstr( Command, ":" ) == NULL && strstr( Command, "\\" ) == NULL )
	    {
                strcpy( Command, Filnam( Command ) ) ; /* Find file */
	    } ;
            Help_Line[ Level - 1 ] = Lr ;
            fclose( Help_File ) ;
            Help_File = fopen( Command, "rt" ) ;
            Lr = 0 ;
            if( Help_File == NULL )
            {
		perror( "Help" ) ;
		clearerr( Help_File ) ;
                Help_File = fopen( &Help_Files[ Level ], "rt" ) ;
		/* Open previous file */
                Lr = 0 ;
                if( Help_Line[ Level ] > 0 )
		{
                    for( Dummy = 1; Dummy <= Help_Line[ Level ]; Dummy++ )
		    {
			fgets( &Z, 256, Help_File ) ;
		    } ;
		} ;
                Lr = Help_Line[ Level ] ;
                return True ;
            } ;
            strcpy( &Help_Files[ Level ], Command ) ;
        }
	else
        {
            if( Command[ 0 ] == '*' && Command[ 1 ] != '|' )
            {
                if( Topic == '*' ) /* Wildcard topic match */
                {
                    if( Icf ) /* Sub-topic was in a separate file */
                    {
                        Further() ; /* Display further topics */
                        Icf = False ;
                        fclose( Help_File ) ;
                        Help_File = fopen( &Help_Files[ Level - 1 ], "rt" ) ;
                        Lr = Help_Line[ Level - 1 ] ;
                        for( Dummy = 1; Dummy <= Lr; Dummy++ )
			{
			    fgets( &Z, 256, Help_File ) ;
			} ;
                        strcpy( Command, Z ) ;
                    }
		    else
                    {
                        Out( NULL ) ;
                        Out( NULL ) ;
                        Out( &Command[ 1 ] ) ;
                    } ;
                    Out( NULL ) ;
                    goto Next_Line1 ;
                } ;
                if( !Icf && Level > 0 && strcmp( Topic, "?" ) != 0 )
		{
		    return True ;
		} ;
                goto Prompt ;
            } ;
            if( Command[ 0 ] != '*' )
            {
                if( strlen( X ) > 0 ) /* Sub topics specified */
                {
                    Help_Line[ Level ] = Lr ;
                    Level = Level + 1 ;
                    T = Print_Help( X ) ;
                    Level = Level - 1 ;
                    if( !T )
                    {
                        return False ; /* Error on a subtopic */
                    } ;
                    Help_Line[ Level ] = Lr ;
                    Help_File = fopen( &Help_Files[ Level ], "rt" ) ;
                    Lr = 0 ;
                    if( Topic == '*' )
                    {
                        for( Dummy = 1; Dummy <= Help_Line[ Level ]; Dummy++ )
			{
                            fgets( &Z, 256, Help_File ) ;
			} ;
                        Lr = Help_Line[ Level ] ;
                    } ;
                    goto Done ;
                } ;
                Out( &Command ) ;
                Lc = Lc + 1 ;
            } ;
        } ;
    } ; /* EOF */
    if( strcmp( Topic, "*" ) == 0 && Icf ) /* EOF with wildcard */
    {
        fclose( Help_File ) ;
        Help_File = fopen( &Help_Files[ Level - 1 ], "rt" ) ;
        Icf = False ;
        Lr = Help_Line[ Level - 1 ] ;
        for( Dummy = 1; Dummy <= Lr; Dummy++ )
	{
	    fgets( &Z, 256, Help_File ) ;
	} ;
        goto Next_Line ;
    } ;
Done:
    if( strcmp( Topic, "*" ) == 0 )
    {
	return True ; /* End of file on wild-card so back up */
    } ;
Prompt:
    if( Wildcard < Level )
    {
	return True ;
    } ;
    rewind( Help_File ) ;
    Lr = 0 ;
    Further() ; /* Display further topics */
Prompt1:
    if( Level > 0 )
    {
	for( Dummy = 1; Dummy <= Level; Dummy++ )
	{
	    printf( "%s ", &Topics[ Dummy ] ) ;
	} ;
    } ;
    printf( "Topic? " ) ;
    gets( &X ) ;
    Line_Count = 0 ;
    Edit( X, X, 188 ) ;
    if( strlen( X ) == 0 )
    {
	return True ;
    } ;
    if( strcmp( X, "?" ) == 0 )
    {
        X[ 0 ] = 0 ;
        goto Start ; /* Re-display current help */
    } ;
    Dummy = Level ;
    if( Level > 0 )
    {
	for( Level = 1; Level <= Dummy; Level++ )
	{
            Out( &Topics[ Level ] ) ;
	    Out( NULL ) ;
	} ;
    } ;
    Help_Line[ Level ] = Lr ;
    Level = Level + 1 ;
    T = Print_Help( X ) ;
    Level = Level - 1 ;
    Help_File = fopen( &Help_Files[ Level ], "rt" ) ;
    Lr = 0 ;
    goto Prompt1 ;
} ; /* Print_Help */


void Help( char *Command, char *Command1 )
{
    strcpy( Command, Filnam( Command ) ) ; /* Find help file */
    Help_File = fopen( Command, "rt" ) ;
    if( Help_File == NULL )
    {
	clearerr( Help_File ) ;
        printf( "Help not available\n" ) ;
        return ;
    } ;
    strcpy( &Help_Files[ 0 ], Command ) ;
    Level = 0 ;
    if( Command1 != NULL )
    {
	Edit( Command1, Command1, 188 ) ;
	if( strlen( Command1 ) > 0 )
	{
	    Level = 1 ;
	} ;
    } ;
    Wildcard = 255 ;
    Line_Count = 0 ;
    Print_Help( Command1 ) ;
    fclose( Help_File ) ;
} ;
