/*
              Program Name : Misc
              Package Name : LB
              Purpose      : Misc. routines
              Institution  : Conroy & Conroy Company
              Original Vers: 22-Aug-86
              Date Written : 25-Jan-1990
              Written By   : Alan Conroy
              Version      : 2.0

	      Copyright (C) 1986-1990 by Alan Conroy.  Released to the public domain.

              TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *********************************************************
        *                                                       *
        *        M O D I F I C A T I O N   H I S T O R Y        *
        *                                                       *
        *     DATE      BY             REASON                   *
        *                                                       *
        *********************************************************

        *********************************************************
        *                                                       *
        *           P R O G R A M   P U R P O S E               *
        *                                                       *
        *********************************************************

	  These functions perform various assorted operations.
*/

#include <mem.h>
#include <stdlib.h>
#include <string.h>
#include "misc.h"

char *Mid( char *C, int Beginning, int Count )
{

int A, B ;
char *X ;

    A = Count ;
    B = Beginning ;
    if( Beginning < 1 )
    {
        A = A + Beginning - 1 ;
        B = 1 ;
    } ;
    if( C == NULL ) /* Passed string is null */
    {
	return NULL ;
    } ;
    if( A < 1 || B > strlen( C ) ) /* Invalid start or count */
    {
	return NULL ;
    } ;
    X = malloc( A + 1 ) ;
    X[ A ] = 0 ;
    memmove( X, &C[ B - 1 ], A ) ;
    return X ;
} ;



char *Space( int X )
{

char *A ;
int B ;

    A = malloc( X + 1 ) ;
    if( A != NULL )
    {
        for( B = 0; B < X; B++ )
	{
	    A[ B ] = ' ' ;
	} ;
	A[ X ] = 0 ;
    } ;
    return A ;
} ;


/* Convert Radix-50 integer to string. */
char *Rad( int Source )
{

static char Buffer[ 4 ] ;
char Radix[] = " ABCDEFGHIJKLMNOPQRSTUVWXYZ$. 0123456789 " ;
int Power[] = { 1, 40, 1600 } ;

long X, Y  ;
int Xxx, Z ;

    Buffer[ 4 ] = 0 ;
    X = Source ;
    if( X < 0 )
    {
	X = 65536 + X ;
    } ;
    Z = 0 ;
    while( Z < 3 )
    {
        Y = Power[ 2 - Z ] ;
        Xxx = X / Y ;
        Buffer[ Z ] = Radix[ Xxx ] ;
	Z = Z + 1 ;
        X = X - Xxx * Y ;
    } ;
    return &Buffer ;
} ;


/* This module converts a three (3) character string into a two byte Radix-50
   value that may be used with the RAD function. */
int Rad50( char *Source )
{

char Radix[] = " ABCDEFGHIJKLMNOPQRSTUVWXYZ$. 0123456789" ;
int Power[] = { 1, 40, 1600 } ;
char Buffer[ 4 ] = "    " ;
long X ;
int Xx, Z ;

    Buffer[ 3 ] = 0 ;

    /* The following code copies a maximum of three (3) characters from
       the passed string to the buffer, making sure that the buffer is
       left padded with spaces if less than three characters are passed */
    if( Source == NULL )
    {
	Xx = 0 ;
    }
    else
    {
	Xx = strlen( Source ) ;
	X = 3 - Xx ; /* Starting position for copy */
	if( X < 0 )
	{
	    X = 0 ;
	} ;
	if( Xx > 3 )
	{
	    Xx = 3 ; /* Maximum number of characters to copy */
	} ;
	memmove( &Buffer[ X ], &Source[ 0 ], Xx ) ;
    } ;

    X = 0 ;
    for( Xx = 0; Xx < 3; Xx++ )
    {
	Z = 0 ;
	while( Z < 41 && Radix[ Z ] != Buffer[ 2 - Xx ] ) /* Find character */
	{
	    Z = Z + 1 ;
	} ;
	if( Z == 41 )
	{
	    Z = 0 ;
	} ;
        X = X + Z * Power[ Xx ] ;
    } ;
    if( X > 32767 )
    {
	return X - 65536 ; /* normalize to 16 bit 2's-complement */
    } ;
    return X ;
} ;
