{
        Program Name : MSWIN
        Package Name : LB
        Purpose      : Routines specific to Microsoft Windows
        Institution  : Conroy & Conroy Co.
        Date Written : 28-May-2003
        Written By   : Alan Conroy
        Version      : 1.0

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *    DATE        BY          REASON                         *
        *                                                           *
        *                                                           *
        *************************************************************

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

          This unit contains support for Microsoft Windows programming.
}

unit MSWin ;

interface

{ Requests a debugger for the target control.  Result contains a pointer to an
  instance of the debugger, or 0 if not available. }
function XWM_Get_Debugger : integer ;

{ Requests a rectangle for where the pop-up hint should be shown for the target
  control.  LParam contains the address of a TRect to fill.  Rectangle is in
  client coordinates for the control. }
function XWM_Get_Hint_Rect : integer ;

{ Requests a rectangle for where the pop-up hint should not be shown for the
  target control.  In other words, this is the part of the control for which the
  hint shows, so we don't want to cover it.  LParam contains the address of a
  TRect to fill.  Rectangle is in client coordinates for the control. }
function XWM_Get_Hint_Exclusion_Rect : integer ;

// Returns text of passed extended windows message.
function XWM_Message_Text( X : integer ) : string ;

implementation

uses // Borland...
     Windows ; // RegisterWindowMessage

var // Extended Windows Messages...
    _XWM_Get_Debugger : integer ;
    _XWM_Get_Hint_Rect : integer ;
    _XWM_Get_Hint_Exclusion_Rect : integer ;

function XWM_Get_Debugger : integer ;

begin
    Result := _XWM_Get_Debugger ;
end ;


function XWM_Get_Hint_Rect : integer ;

begin
    Result := _XWM_Get_Hint_Rect ;
end ;


function XWM_Get_Hint_Exclusion_Rect : integer ;

begin
    Result := _XWM_Get_Hint_Exclusion_Rect ;
end ;


function XWM_Message_Text( X : integer ) : string ;

begin
    Result := '' ;
    if( X = _XWM_Get_Debugger ) then
    begin
        Result := 'XWM_Get_Debugger' ;
    end else
    if( X = _XWM_Get_Hint_Rect ) then
    begin
        Result := 'XWM_Get_Hint_Rect' ;
    end else
    if( X = _XWM_Get_Hint_Exclusion_Rect ) then
    begin
        Result := 'XWM_Get_Hint_Exclusion_Rect' ;
    end ;
end ;


initialization
    _XWM_Get_Debugger := RegisterWindowMessage( 'XWM_Get_Debugger' ) ;
    _XWM_Get_Hint_Rect := RegisterWindowMessage( 'XWM_Get_Hint_Rect' ) ;
    _XWM_Get_Hint_Exclusion_Rect := RegisterWindowMessage( 'XWM_Get_Hint_Exclusion_Rect' ) ;
end.