/*
        Program Name : _Streams
        Package Name : LB
        Purpose      : TSStream object
        Institution  : Conroy & Conroy Co.
        Date Written : 2002
        Written By   : Alan Conroy
        Version      : 1.0

	Copyright (C) 2002-2003 by Alan Conroy.  All rights reserved.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *    DATE        BY          REASON                         *
        *                                                           *
        *                                                           *
        *************************************************************

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

*/

#include "cominter.h"

    class TStream : public TCommon_COM_Interface
    {
       public: // API...
          // Returns True if there is no more data in the stream to read.
          virtual bool __stdcall At_End() = 0 ;

          // Returns last error code
          virtual void __stdcall Last_Error( TUEC& UEC ) = 0 ;

          // Reads the specified number of bytes from the stream.
          // Size is modified to be the actual bytes transferred. }
          virtual void __stdcall Read( void* Buffer, int& _Size ) = 0 ;

          // Reads one line of input, up to the size of the buffer.
          // The line is assumed to end at an ASCII 13 code.  The
          // ASCII 13 code is not included in the returned data.
          // Size is modified to be the actual bytes transferred.
          virtual void __stdcall Read_Line( void* Buffer, int& _Size ) = 0 ;

          // Position to specified byte within streamed data.
          virtual void __stdcall Seek( int Position ) = 0 ;

          // Returns size of stream data, in bytes.  -1 indicate that
          // the size is unknown or larger than 2^31.
          virtual int __stdcall Size() = 0 ;

          // Writes the specified buffer, of the specified size in
          // bytes, to the stream.
          virtual void __stdcall Write( void* Buffer, int _Size ) = 0 ;

          // Writes the specified null-terminated text to the stream.
          // An ASCII code 13 is appended to the text on output.
          virtual void __stdcall Write_Line( char* Buffer ) = 0 ;
    }; // TStream

