{$N+}
{
        Program Name : CEFUtil
        Package Name : CEF
        Purpose      : CEF_Util definitions
        Institution  :
        Date Written : 2-Jan-2007
        Written By   : Alan Conroy
        Version      : 1.0

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        Released to the public domain.
        
        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *    DATE        BY          REASON                         *
        *                                                           *
        *                                                           *
        *************************************************************

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

          This unit contains all of the type definitions for the CEF_Util DLL.
}

unit _CEFUtil ;

interface

uses // C&C...
     _UEHDefs ; // TUEC

type TCEF_Watchpoint = class
                          public { API... }
                              function Get_Address : int64 ;
                                  virtual ; stdcall ; abstract ;

                              function Get_Access : longint ;
                                  virtual ; stdcall ; abstract ;

                              procedure Set_Access( Value : longint ) ;
                                  virtual ; stdcall ; abstract ;


                              function Serialize : PChar ;
                                  virtual ; stdcall ; abstract ;

                              procedure Deserialize( Image : PChar ) ;
                                  virtual ; stdcall ; abstract ;


                              property Address : int64
                                  read Get_Address ;
                              property Access : longint
                                  read Get_Access
                                  write Set_Access ;
                      end ;

    TCEF_Watchpoint_Manager = class
                                  public // API...
                                      procedure Clear ;
                                          virtual ; stdcall ; abstract ;
                                      function Clear_Watchpoint( Address : int64 ;
                                          Access : longint ) : TUEC ;
                                          virtual ; stdcall ; abstract ;
                                      function Create_Watchpoint( Ad : int64 ;
                                          Ac : longint ) : TCEF_Watchpoint ;
                                          virtual ; stdcall ; abstract ;
                                      function Count : longint ;
                                          virtual ; stdcall ; abstract ;
                                      procedure Deserialize( Source : PChar ) ;
                                          virtual ; stdcall ; abstract ;
                                      function Serialize : PChar ;
                                          virtual ; stdcall ; abstract ;
                                      procedure Terminate ;
                                          virtual ; stdcall ; abstract ;
                                      function Watchpoint_At( Address : int64 ) : TCEF_Watchpoint ;
                                          virtual ; stdcall ; abstract ;
                              end ;

type TCEF_Character_Set = class
                              public // Property handlers...
                                  function Get_Invert : boolean ;
                                      virtual ; stdcall ; abstract ;

                                  procedure Set_Invert( Value : boolean ) ;
                                      virtual ; stdcall ; abstract ;

                              public // API...
                                  procedure Clear ;
                                      virtual ; stdcall ; abstract ;
                                  function Draw( Handle, X, Y, Index : integer ) : boolean ;
                                      virtual ; stdcall ; abstract ;
                                  function Has_Glyph( Index : integer ) : boolean ;
                                      virtual ; stdcall ; abstract ;
                                  function Height : integer ;
                                      virtual ; stdcall ; abstract ;
                                  procedure Initialize ;
                                      virtual ; stdcall ; abstract ;
                                  procedure Load( Name : PChar ) ;
                                      virtual ; stdcall ; abstract ;
                                  procedure Terminate ;
                                      virtual ; stdcall ; abstract ;
                                  function Width( Index : longint ) : longint ;
                                      virtual ; stdcall ; abstract ;

                                  property Invert : boolean
                                      read Get_Invert
                                      write Set_Invert ;
                          end ; // TCharacter_Set

     TCEF_Key_Mapper = class
                           public
                               procedure Add_Key( Name : PChar ) ;
                                      virtual ; stdcall ; abstract ;
                               procedure Add_Mapping( Name : PChar ) ;
                                      virtual ; stdcall ; abstract ;
                               procedure Clear_Keys( Mapping_Only : boolean ) ;
                                      virtual ; stdcall ; abstract ;
                               procedure Clear_Mappings ;
                                      virtual ; stdcall ; abstract ;
                               function Query : boolean ;
                                      virtual ; stdcall ; abstract ;
                               function Mapping( Name : PChar ) : PChar ;
                                      virtual ; stdcall ; abstract ;
                               procedure Set_Mapping( Key, Mapping : PChar ) ;
                                      virtual ; stdcall ; abstract ;
                               procedure Terminate ;
                                      virtual ; stdcall ; abstract ;
                       end ;

implementation

end.
